groups:
  - name: AllInstances
    rules: 
      - alert: InstanceDown
        expr: up == 0
        for: 30s

      - alert: HostHighCpuLoad
        expr: 100 - (avg by(instance) (rate(node_cpu_seconds_total{mode="idle"}[2m])) * 100) > 85
        for: 0m
#        labels:
#          severity: warning
        annotations:
          summary: Host high CPU load (instance {{ $labels.instance }})
          description: "CPU load is > 5%\n  VALUE = {{ $value }}\n  LABELS = {{ $labels }}"        
          
#      - alert: HostUnusualNetworkThroughputIn
#        expr: sum by (instance) (rate(node_network_receive_bytes_total[2m])) / 1024 / 1024 > 50
#          for: 0m
#        annotations:
#          summary: Host unusual network throughput in (instance {{ $labels.instance }})
#          description: "Host network interfaces are probably receiving too much data (> 50 MB/s)\n  VALUE = {{ $value }}\n  LABELS = {{ $labels }}"
          
#      - alert: HostUnusualNetworkThroughputOut
#        expr: sum by (instance) (rate(node_network_transmit_bytes_total[2m])) / 1024 / 1024 > 50
#          for: 0m
#        annotations:
#          summary: Host unusual network throughput in (instance {{ $labels.instance }})
#          description: "Host network interfaces are probably transmitting too much data (> 50 MB/s)\n  VALUE = {{ $value }}\n  LABELS = {{ $labels }}"


#      - alert: http_service_down
#        expr: http_response_code{status_code!~"200|302"}
#          for: 10s
#labels:
#  severity: high          

#      - alert: NginxLatencyHigh
#        expr: histogram_quantile(0.99, sum(rate(nginx_http_request_duration_seconds_bucket[2m])) by (host, node)) > 1
#        for: 30s
 #       labels:
 #         severity: warning
#        annotations:
#          summary: Nginx latency high (instance {{ $labels.instance }})
#          description: "Nginx p99 latency is higher than 1 second\n  VALUE = {{ $value }}\n  LABELS = {{ $labels }}"
          
      - alert: BlackboxSlowProbe
        expr: avg_over_time(probe_duration_seconds[1m]) > 1
        for: 1m
        labels:
          severity: warning
        annotations:
          summary: Blackbox slow probe (instance {{ $labels.instance }})
          description: "Blackbox probe took more than 1s to complete\n  VALUE = {{ $value }}\n  LABELS = {{ $labels }}"

      - alert: BlackboxProbeHttpFailure
        expr: probe_http_status_code <= 199 OR probe_http_status_code >= 400
        for: 0m
        labels:
          severity: critical
        annotations:
          summary: Blackbox probe HTTP failure (instance {{ $labels.instance }})
          description: "HTTP status code is not 200-399\n  VALUE = {{ $value }}\n  LABELS = {{ $labels }}"

      - alert: PrometheusTargetMissingWithWarmupTime
        expr: sum by (instance, job) ((up == 0) * on (instance) group_right(job) (node_time_seconds - node_boot_time_seconds > 600))
        for: 0m
        labels:
          severity: critical
        annotations:
          summary: Prometheus target missing with warmup time (instance {{ $labels.instance }})
          description: "Allow a job time to start up (10 minutes) before alerting that it's down.\n  VALUE = {{ $value }}\n  LABELS = {{ $labels }}"
      